function varargout = elastic_part(varargin)
% ELASTIC_PART M-file for elastic_part.fig
%      ELASTIC_PART, by itself, creates a new ELASTIC_PART or raises the existing
%      singleton*.
%
%      H = ELASTIC_PART returns the handle to a new ELASTIC_PART or the handle to
%      the existing singleton*.
%
%      ELASTIC_PART('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in ELASTIC_PART.M with the given input arguments.
%
%      ELASTIC_PART('Property','Value',...) creates a new ELASTIC_PART or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before elastic_part_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to elastic_part_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help elastic_part

% Last Modified by GUIDE v2.5 11-Feb-2012 18:47:25

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @elastic_part_OpeningFcn, ...
                   'gui_OutputFcn',  @elastic_part_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before elastic_part is made visible.
function elastic_part_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to elastic_part (see VARARGIN)

% Choose default command line output for elastic_part
handles.output = hObject;

% Handles, receiving data from main GUI
handles_mainGui = getappdata(0,'handles_mainGui');
input_data = getappdata(handles_mainGui, 'input_data');
handles.displacement = input_data(:,1);
handles.force = input_data(:,2);

% plotting the original diagram
plot_forceDisplacement(handles.displacement, handles.force, handles.axes1)

% initialization of "reduction boundary line"
d_force = diff(handles.force)./diff(handles.displacement);
handles.tracker = 0;
i = 1;
while handles.tracker == 0;
    i = i+1;
    if d_force(i+1) < 0.75*d_force(2)
        handles.tracker = i;
    end
end
plot_point(handles.tracker, handles.displacement, handles.force, handles.axes1)

% icons on buttons
checkedImage = importdata('checked.jpg');
set(handles.pushbutton1,'CData',checkedImage);

bbImage = importdata('bb.jpg');
set(handles.pushbutton2,'CData',bbImage);
bImage = importdata('b.jpg');
set(handles.pushbutton3,'CData',bImage);
fImage = importdata('f.jpg');
set(handles.pushbutton4,'CData',fImage);
ffImage = importdata('ff.jpg');
set(handles.pushbutton5,'CData',ffImage);

guidata(hObject, handles);

% UIWAIT makes elastic_part wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = elastic_part_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
handles_updateAxes = getappdata(handles_mainGui, 'handles_updateAxes');

beam_stiffness = handles.force(handles.tracker)/handles.displacement(handles.tracker); 
setappdata(handles_mainGui, 'beam_stiffness', beam_stiffness)

feval(handles_updateAxes);
close

% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.tracker = max(handles.tracker - 10, 0);
plot_forceDisplacement(handles.displacement, handles.force, handles.axes1)
plot_point(handles.tracker, handles.displacement, handles.force, handles.axes1)
guidata(hObject, handles);

% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.tracker = max(handles.tracker - 1, 0);
plot_forceDisplacement(handles.displacement, handles.force, handles.axes1)
plot_point(handles.tracker, handles.displacement, handles.force, handles.axes1)
guidata(hObject, handles);

% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.tracker = max(handles.tracker + 1, max(handles.displacement));
plot_forceDisplacement(handles.displacement, handles.force, handles.axes1)
plot_point(handles.tracker, handles.displacement, handles.force, handles.axes1)
guidata(hObject, handles);

% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.tracker = max(handles.tracker + 10, max(handles.displacement));
plot_forceDisplacement(handles.displacement, handles.force, handles.axes1)
plot_point(handles.tracker, handles.displacement, handles.force, handles.axes1)
guidata(hObject, handles);

%% My functions
function plot_forceDisplacement(displacement, force, handles_axes)
plot(handles_axes, displacement, force)
hold on

function plot_point(tracker, displacement, force, handles_axes)
tracker_x = [0,displacement(tracker)];
tracker_y = [0,force(tracker)];
plot(handles_axes, tracker_x, tracker_y,'-ro','LineWidth', 2, 'MarkerEdgeColor','r', 'MarkerSize',10)
text(displacement(tracker), force(tracker),['    stiffness = ', num2str(force(tracker)/displacement(tracker)/1000, ' %.3f'), ' kN/m'],'HorizontalAlignment','left')
hold off

function plot_forceDisplacement2(displacement, force, handles_axes)
plot(handles_axes, displacement, force, '-r', 'LineWidth',2)
