function varargout = postprocessing(varargin)
%POSTprocess M-file for postprocess.fig
%      POSTprocess, by itself, creates a new POSTprocess or raises the existing
%      singleton*.
%
%      H = POSTprocess returns the handle to a new POSTprocess or the handle to
%      the existing singleton*.
%
%      POSTprocess('Property','Value',...) creates a new POSTprocess using the
%      given property value pairs. Unrecognized properties are passed via
%      varargin to postprocessing_OpeningFcn.  This calling syntax produces a
%      warning when there is an existing singleton*.
%
%      POSTprocess('CALLBACK') and POSTprocess('CALLBACK',hObject,...) call the
%      local function named CALLBACK in POSTprocess.M with the given input
%      arguments.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help postprocess

% Last Modified by GUIDE v2.5 26-Feb-2012 12:59:11

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @postprocessing_OpeningFcn, ...
                   'gui_OutputFcn',  @postprocessing_OutputFcn, ...
                   'gui_LayoutFcn',  [], ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
   gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before postprocess is made visible.
function postprocessing_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   unrecognized PropertyName/PropertyValue pairs from the
%            command line (see VARARGIN)

% Choose default command line output for postprocess
handles.output = hObject;

% Handles, receiving data from main GUI
handles_mainGui = getappdata(0,'handles_mainGui');
setappdata(handles_mainGui,'handles_postprocessingGui',gcf)  % get handles to postprocessing GUI

% Default setting of the diagram
switch_diagram = 1;
setappdata(handles_mainGui,'switch_diagram',switch_diagram);

% Calculate average %%%%%%%%%%%%%%%%%%%%% AVERAGES DISABLED  !!!!!!!!!!!!!!
%postprocess = getappdata(handles_mainGui, 'postprocess');
%postprocess(postprocess(1).nF+1).names = 'AVERAGE';
%setappdata(handles_mainGui, 'postprocess', postprocess);

%sizes = zeros(postprocess(1).nF,1);
%for i = 1:postprocess(1).nF
%    sizes(i) = size(postprocess(i).data,1);
%end
%avg_size = min(sizes);

%cumulative_data = zeros(avg_size,4);
%for i = 1:postprocess(1).nF
%    cumulative_data(:,:) = cumulative_data(:,:) + postprocess(i).data(1:avg_size,:);
%end
%averages = cumulative_data/postprocess(1).nF;
handles_postprocessingGui = getappdata(handles_mainGui,'handles_postprocessingGui');
%setappdata(handles_mainGui, 'averages', averages)

% Update handles structure
guidata(hObject, handles);

setappdata(handles_postprocessingGui, 'textbox', handles.text1)
updateAxes

% UIWAIT makes postprocess wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = postprocessing_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
switch_diagram = getappdata(handles_mainGui,'switch_diagram');
if switch_diagram == 1
    set(handles.pushbutton1,'String', 'switch to force - displ. diagram')
    switch_diagram = 2;
    setappdata(handles_mainGui, 'switch_diagram', switch_diagram);
    updateAxes
else
    set(handles.pushbutton1,'String', 'switch to stress - strain diagram')
    switch_diagram = 1;
    setappdata(handles_mainGui, 'switch_diagram', switch_diagram);
    updateAxes
end

guidata(hObject, handles);

% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

newFigure = figure;
set(newFigure,'Position',[100 100 800 600])

handles_mainGui = getappdata(0,'handles_mainGui');
handles_postprocessingGui = getappdata(handles_mainGui,'handles_postprocessingGui');
handles_axes = findobj(handles_postprocessingGui, 'type', 'axes');
copyobj(handles_axes,newFigure);

handles_axes2 = findobj(newFigure, 'type', 'axes');
set(handles_axes2,'Position',[10 5 145 40])
%copyobj(legend_handles,newFigure);

% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
run results_table


function updateAxes

handles_mainGui = getappdata(0,'handles_mainGui');

postprocess = getappdata(handles_mainGui, 'postprocess');
switch_diagram = getappdata(handles_mainGui,'switch_diagram');
handles_postprocessingGui = getappdata(handles_mainGui,'handles_postprocessingGui');

textbox = getappdata(handles_postprocessingGui, 'textbox');
%averages = getappdata(handles_mainGui, 'averages');

cc = hsv(postprocess(1).nF);                           % list of colors
if switch_diagram == 1
    for i = 1:postprocess(1).nF
        data = postprocess(i).data;
        plot(data(:,2)*1e3,data(:,1),'color',cc(i,:));
        hold on
    end
    %plot(averages(:,2)*1e3,averages(:,1),'color','k','LineWidth',3)
    xlabel('displacement  (\delta) [mm]','FontSize',14)
    ylabel('force  (F) [N]','FontSize',14)
    
    set(textbox, 'String',...
        'NOTE: self-weight IS NOT included in the force - displacement diagram')
    hold off
else
    for i = 1:postprocess(1).nF
        data = postprocess(i).data;
        plot(data(:,4), data(:,3)/1e6,'color',cc(i,:))
        hold on
    end
    %plot(averages(:,4),averages(:,3),'color','k','LineWidth',3)
    xlabel('strain  (\epsilon) [-]','FontSize',14)
    ylabel('stress  (\sigma) [MPa]','FontSize',14)
    
    
    set(textbox, 'String',...
        'NOTE: self-weight IS included in the digram, the softening part is NOT true')
    hold off
end
legend_handles = legend(postprocess.names);
