function varargout = results_table(varargin)
% RESULTS_TABLE M-file for results_table.fig
%      RESULTS_TABLE, by itself, creates a new RESULTS_TABLE or raises the existing
%      singleton*.
%
%      H = RESULTS_TABLE returns the handle to a new RESULTS_TABLE or the handle to
%      the existing singleton*.
%
%      RESULTS_TABLE('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in RESULTS_TABLE.M with the given input arguments.
%
%      RESULTS_TABLE('Property','Value',...) creates a new RESULTS_TABLE or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before results_table_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to results_table_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help results_table

% Last Modified by GUIDE v2.5 26-Feb-2012 22:04:58

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @results_table_OpeningFcn, ...
                   'gui_OutputFcn',  @results_table_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before results_table is made visible.
function results_table_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to results_table (see VARARGIN)

% Choose default command line output for results_table
handles.output = hObject;

% Handles, receiving data from main GUI
handles_mainGui = getappdata(0,'handles_mainGui');
postprocess = getappdata(handles_mainGui, 'postprocess');
%averages = getappdata(handles_mainGui, 'averages');
rowHeaders = getappdata(handles_mainGui, 'rowHeaders');

A = zeros(postprocess(1).nF+3,6);
for i = 1:postprocess(1).nF
    for j = 1:6
        A(i,j) = postprocess(i).aux_data(j);
    end
end

for i = 1:6
    A(postprocess(1).nF+1,i) = mean(A(1:end-3,i));
end
for i = 1:6
    A(postprocess(1).nF+2,i) = std(A(1:end-3,i));
end
for i = 1:6
    A(postprocess(1).nF+3,i) = A(end-1,i)/A(end-2,i)*100;
end

[hist_y hist_x] = hist(A(1:end-3,5));
f = figure;
set(f,'Position',[200 200 900 450])
subplot(1,2,1)
bar(hist_x, hist_y, 0.6)
set(gca,'YLim',[0 max(hist_y)*1.2],'YTick',1:round(max(hist_y)));
xlabel('Young''s modulus [MPa]','FontSize',12)
ylabel('frequency','FontSize',12)

[hist_y hist_x] = hist(A(1:end-3,6));
subplot(1,2,2)
bar(hist_x, hist_y, 0.6, 'r')
set(gca,'YLim',[0 max(hist_y)*1.2],'YTick',1:round(max(hist_y)));
xlabel('fracture energy [J/m2]','FontSize',12)
ylabel('frequency','FontSize',12)

set(handles.uitable1,'Data',A);
set(handles.uitable1,'RowName',[rowHeaders, 'MEAN VALUES', 'standard deviation','coefficient of variation [%]']);
columnHeaders = {'F_max [N]','deflection at F_max [mm]', 'sigma_max [MPa]',...
    'strain at sigma_max [-]','E [MPa]', 'Gf [J/m2]'};
set(handles.uitable1,'ColumnName',columnHeaders);


% Update handles structure
guidata(hObject, handles);

% UIWAIT makes results_table wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = results_table_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;
